// C Source File
// Created 11/9/2002; 8:53:14 PM

#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function
static unsigned short shipup[]={0b0000011000000000,
                                0b0000111100000000,
                                0b0001111110000000,
                                0b0011111111000000,
                                0b0111111111100000,
                                0b1111111111110000};                             
static unsigned short shipupright[]={0b1111111100000000,
                                     0b0111111110000000,
                                     0b0011111110000000,
                                     0b0001111110000000,
                                     0b0000111110000000,
                                     0b0000011110000000,
                                     0b0000001110000000,
                                     0b0000000110000000,
                                     0b0000000010000000};                               
static unsigned char shipright[]={0b10000000,
                                  0b11000000,
                                  0b11100000,
                                  0b11110000,
                                  0b11111000,
                                  0b11111100,
                                  0b11111100,
                                  0b11111000,
                                  0b11110000,
                                  0b11100000,
                                  0b11000000,
                                  0b10000000};                               
static unsigned short shipdownright[]={0b0000000010000000,
                                        0b0000000110000000,
                                        0b0000001110000000,
                                        0b0000011110000000,
                                        0b0000111110000000,
                                        0b0001111110000000,
                                        0b0011111110000000,
                                        0b0111111110000000,
                                        0b1111111100000000};                               
static unsigned short shipdown[]={0b1111111111110000,
                                  0b0111111111100000,
                                  0b0011111111000000,
                                  0b0001111110000000,
                                  0b0000111100000000,
                                  0b0000011000000000};                               
static unsigned short shipdownleft[]={0b1000000000000000,
                                      0b1100000000000000,
                                      0b1110000000000000,
                                      0b1111000000000000,
                                      0b1111100000000000,
                                      0b1111110000000000,
                                      0b1111111000000000,
                                      0b1111111100000000,
                                      0b0111111110000000};                               
static unsigned char shipleft[]={0b00000100,
                                  0b00001100,
                                  0b00011100,
                                  0b00111100,
                                  0b01111100,
                                  0b11111100,
                                  0b11111100,
                                  0b01111100,
                                  0b00111100,
                                  0b00011100,
                                  0b00001100,
                                  0b00000100};                               
static unsigned short shipupleft[]={0b0111111110000000,
                                    0b1111111100000000,
                                    0b1111111000000000,
                                    0b1111110000000000,
                                    0b1111100000000000,
                                    0b1111000000000000,
                                    0b1110000000000000,
                                    0b1100000000000000,
                                    0b1000000000000000};
static unsigned char bulletsprite[]={0b11000000,
                                     0b11000000};
static unsigned short basteroid[]={0b0000001111000000,
                                   0b0000011111100000,
                                   0b0000111111110000,
                                   0b0011111111111100,
                                   0b0111111111111110,
                                   0b0111111111111110,
                                   0b1111111111111111,
                                   0b1111111111111111,
                                   0b1111111111111111,
                                   0b1111111111111111,
                                   0b0111111111111110,
                                   0b0111111111111110,
                                   0b0011111111111100,
                                   0b0000111111110000,
                                   0b0000011111100000,
                                   0b0000001111000000};
static unsigned char lasteroid[]={0b00011000,
                                  0b00111100,
                                  0b01111110,
                                  0b11111111,
                                  0b11111111,
                                  0b01111110,
                                  0b00111100,
                                  0b00011000};
static unsigned short shieldsprite[]={0b0000011111100000,
																			0b0001100000011000,
																			0b0010000000000100,
																			0b0100000000000010,
																			0b0100000000000010,
																			0b1000000000000001,
																			0b1000000000000001,
																			0b1000000000000001,
																			0b1000000000000001,
																			0b1000000000000001,
																			0b1000000000000001,
																			0b0100000000000010,
																			0b0100000000000010,
																			0b0010000000000100,
																			0b0001100000011000,
																			0b0000011111100000};																			
int ship[10],bullet[48]={},littleasteroid[80]={},bigasteroid[20]={},temp[10],bulletdelay=0,justfired=0,level,oldlevel,foundbreak,shieldstate,score,highscore=0,difficulty,pausedelay;
int unsigned delaytime;
char buffer[50];
void _main(void){
	temp[0]=1;
	difficulty=1;
	topofmenu:
	clrscr();
	FontSetSys(F_8x10);
	DrawStr(LCD_WIDTH/2-36,2,"Asteroids",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(20,30,"Start Game",A_NORMAL);
	DrawStr(20,43,"Difficulty:",A_NORMAL);
	DrawStr(20,56,"Instructions",A_NORMAL);
	DrawStr(20,69,"Exit",A_NORMAL);
	if(temp[0]==1) DrawStr(20,30,"Start Game",A_REVERSE);
	if(temp[0]==2) DrawStr(20,43,"Difficulty:",A_REVERSE);
	if(temp[0]==3) DrawStr(20,56,"Instructions",A_REVERSE);
	if(temp[0]==4) DrawStr(20,69,"Exit",A_REVERSE);
	FontSetSys(F_4x6);
	DrawStr(10,LCD_HEIGHT-6,"by Thomas Stout gattan007@hotmail.com",A_NORMAL);
	FontSetSys(F_6x8);
	sprintf(buffer,"%d",difficulty);
	DrawStr(87,43,buffer,A_NORMAL);
	temp[1]=ngetchx();
	if(temp[1]==337) temp[0]=temp[0]-1;
	if(temp[1]==340) temp[0]=temp[0]+1;
	if(temp[0]==0) temp[0]=4;
	if(temp[0]==5) temp[0]=1;
	if(temp[1]==13) goto selectionmade;
	goto topofmenu;
	selectionmade:
	if(temp[0]==1){
		if(difficulty==1) delaytime=65000;
		if(difficulty==2) delaytime=50000;
		if(difficulty==3) delaytime=35000;
		if(difficulty==4) delaytime=20000;
		startgame();
	}
	if(temp[0]==2){
		difficulty=difficulty+1;
		if(difficulty==5) difficulty=1;
		goto topofmenu;
	}
	if(temp[0]==3) goto displayinstructions;
	if(temp[0]==4) exit(0);
	displayinstructions:
	clrscr();
	FontSetSys(F_4x6);
  DrawStr(1,1,"2nd-Fire",A_NORMAL);
  DrawStr(1,11,"Diamond-Shield",A_NORMAL);
  DrawStr(1,21,"Left/Right-Ship Direction",A_NORMAL);
  DrawStr(1,31,"Up/Down-Accelerate/Decelerate",A_NORMAL);
  DrawStr(1,41,"Shift-Pause",A_NORMAL);
  DrawStr(1,51,"Esc-Quit Game",A_NORMAL);
  DrawStr(1,71,"The bar on the right side of the screen",A_NORMAL);
  DrawStr(1,81,"is you shield level. The bar on the left",A_NORMAL);
  DrawStr(1,91,"side is your health level.",A_NORMAL);
	ngetchx();
  goto topofmenu;
}
startgame(void){	
  OSSetSR (0x0700);
  level=1;
  oldlevel=0;
  score=0;
  clearvariables();
	clrscr();
	createlevel();
	ship[6]=10;  //health left
	temp[8]=1;
	pausedelay=0;
	gameloop();
}
gameloop(void){
	if(level!=oldlevel){
		clrscr();
		oldlevel=level;
		drawship();
		drawasteroids();
		drawstatusbars();
		FontSetSys(F_8x10);
		DrawStr(LCD_WIDTH/2-30,5,"Level",A_NORMAL);
		sprintf(buffer,"%d",level);
		DrawStr(LCD_WIDTH/2+30,5,buffer,A_NORMAL);
		do{
		} while(ngetchx()!=13);
		OSSetSR (0x0700);
	}
	clrscr();
	getinput();
	drawship();
	drawasteroids();
	drawstatusbars();
	if(temp[8]==1){
		shieldstuff();
		moveship();
		bulletstuff();
		moveasteroids();
		detectcollisions();
		checkmisc();
		shieldstate=0;
		ship[5]=ship[5]+1;
	}
	if(ship[5]>50) ship[5]=50;
	if(delaytime/level>1000) delay(delaytime-(level*1000));
	pausedelay=pausedelay-1;
	if(pausedelay<0) pausedelay=0;
	gameloop();
}
getinput(void){
	if(_rowread(0b11111110)&(0b00000001)){
		if(ship[2]==0){
			ship[4]=ship[4]-1;
			if(ship[4]==-4) ship[4]=-3;
			if(ship[4]==-3&&ship[3]!=0) ship[4]=-2;
		}
		if(ship[2]==1){
			ship[4]=ship[4]-1;
			ship[3]=ship[3]+1;
			if(ship[4]==-4) ship[4]=-3;
			if(ship[3]==4) ship[3]=3;
		}
		if(ship[2]==2){
			ship[3]=ship[3]+1;
			if(ship[3]==4) ship[3]=3;
		}
		if(ship[2]==3){
			ship[4]=ship[4]+1;
			ship[3]=ship[3]+1;
			if(ship[4]==4) ship[4]=3;
			if(ship[3]==4) ship[3]=3;
		}
		if(ship[2]==4){
			ship[4]=ship[4]+1;
			if(ship[4]==4) ship[4]=3;
		}
		if(ship[2]==5){
			ship[4]=ship[4]+1;
			ship[3]=ship[3]-1;
			if(ship[4]==4) ship[4]=3;
			if(ship[3]==-4) ship[3]=-3;
		}
		if(ship[2]==6){
			ship[3]=ship[3]-1;
			if(ship[3]==-4) ship[3]=-3;
		}
		if(ship[2]==7){
			ship[4]=ship[4]-1;
			ship[3]=ship[3]-1;
			if(ship[4]==-4) ship[4]=-3;
			if(ship[3]==-4) ship[3]=-3;
		}
	}
	if(_rowread(0b11111110)&(0b00000100)){
		if(ship[3]<0) ship[3]=ship[3]+1;
		if(ship[3]>0) ship[3]=ship[3]-1;
		if(ship[4]<0) ship[4]=ship[4]+1;
		if(ship[4]>0) ship[4]=ship[4]-1;
	}
	if((_rowread(0b11111110)&(0b00000010))&&temp[9]==0){
		ship[2]=ship[2]-1;
		if(ship[2]==-1) ship[2]=7;
		temp[9]=2;
	}
	if((_rowread(0b11111110)&(0b00001000))&&temp[9]==0){
		ship[2]=ship[2]+1;
		if (ship[2]==8) ship[2]=0;
		temp[9]=2;
	}
	if(_rowread(0b10111111)&(0b00000001)){
	  exit(0);
	}
	if((_rowread(0b11111110)&(0b00100000))&&pausedelay==0){
		temp[8]=temp[8]*-1;
		pausedelay=2;
	}
	if(_rowread(0b11111110)&(0b00010000)&&(bulletdelay==0)){
		shootbullet();
	}
	if(_rowread(0b01111110)&(0b01000000)){
		if(ship[5]>3){
			shieldstate=1;
			ship[5]=ship[5]-3;
		}
		if(ship[5]<=3&&ship[5]>=0){
			ship[5]=ship[5]-3;
		}
	}
	temp[9]=temp[9]-1;
	if(temp[9]<0) temp[9]=0;
}
drawship(void){
	if(ship[2]==0) Sprite16 (ship[0],ship[1],6,shipup,LCD_MEM,SPRT_XOR);
	if(ship[2]==1) Sprite16 (ship[0]+2,ship[1],9,shipupright,LCD_MEM,SPRT_XOR);
	if(ship[2]==2) Sprite8 (ship[0]+5,ship[1]-1,12,shipright,LCD_MEM,SPRT_XOR);
	if(ship[2]==3) Sprite16 (ship[0],ship[1]-2,9,shipdownright,LCD_MEM,SPRT_XOR);
	if(ship[2]==4) Sprite16 (ship[0],ship[1],6,shipdown,LCD_MEM,SPRT_XOR);
	if(ship[2]==5) Sprite16 (ship[0],ship[1]-2,9,shipdownleft,LCD_MEM,SPRT_XOR);
	if(ship[2]==6) Sprite8 (ship[0],ship[1]-1,12,shipleft,LCD_MEM,SPRT_XOR);
	if(ship[2]==7) Sprite16 (ship[0]+2,ship[1],9,shipupleft,LCD_MEM,SPRT_XOR);
}
delay(int unsigned delay){
	do{
		delay=delay-1;
	} while(delay>0);
}
moveship(void){
	ship[0]=ship[0]+ship[3];
	ship[1]=ship[1]+ship[4];
	if(ship[0]<0) ship[0]=LCD_WIDTH;
	if(ship[0]>LCD_WIDTH) ship[0]=0;
	if(ship[1]<0) ship[1]=LCD_HEIGHT;
	if(ship[1]>LCD_HEIGHT) ship[1]=0;
	ship[7]=ship[7]-1;
	if(ship[7]<0) ship[7]=0;
}
shootbullet(void){
	justfired=0;
	temp[0]=0;
	bulletcheck:
	if((bullet[temp[0]]==0)&&(justfired==0)){
		justfired=1;
		bulletdelay=3;
		if (ship[2]==0){
			bullet[temp[0]]=1;
			bullet[temp[0]+1]=ship[0]+6;
			bullet[temp[0]+2]=ship[1]-2;
			bullet[temp[0]+3]=0;
			bullet[temp[0]+4]=-4;
			bullet[temp[0]+5]=30;
		}
		if (ship[2]==1){
			bullet[temp[0]]=1;
			bullet[temp[0]+1]=ship[0]+9;
			bullet[temp[0]+2]=ship[1]-1;
			bullet[temp[0]+3]=4;
			bullet[temp[0]+4]=-4;
			bullet[temp[0]+5]=30;
		}
		if (ship[2]==2){
			bullet[temp[0]]=1;
			bullet[temp[0]+1]=ship[0]+9;
			bullet[temp[0]+2]=ship[1]+5;
			bullet[temp[0]+3]=4;
			bullet[temp[0]+4]=0;
			bullet[temp[0]+5]=30;
		}
		if (ship[2]==3){
			bullet[temp[0]]=1;
			bullet[temp[0]+1]=ship[0]+9;
			bullet[temp[0]+2]=ship[1]+9;
			bullet[temp[0]+3]=4;
			bullet[temp[0]+4]=4;
			bullet[temp[0]+5]=30;
		}
		if (ship[2]==4){
			bullet[temp[0]]=1;
			bullet[temp[0]+1]=ship[0]+6;
			bullet[temp[0]+2]=ship[1]+8;
			bullet[temp[0]+3]=0;
			bullet[temp[0]+4]=4;
			bullet[temp[0]+5]=30;
		}
		if (ship[2]==5){
			bullet[temp[0]]=1;
			bullet[temp[0]+1]=ship[0]-1;
			bullet[temp[0]+2]=ship[1]+9;
			bullet[temp[0]+3]=-4;
			bullet[temp[0]+4]=4;
			bullet[temp[0]+5]=30;
		}
		if (ship[2]==6){
			bullet[temp[0]]=1;
			bullet[temp[0]+1]=ship[0]-1;
			bullet[temp[0]+2]=ship[1]+5;
			bullet[temp[0]+3]=-4;
			bullet[temp[0]+4]=0;
			bullet[temp[0]+5]=30;
		}
		if (ship[2]==7){
			bullet[temp[0]]=1;
			bullet[temp[0]+1]=ship[0]-1;
			bullet[temp[0]+2]=ship[1]-1;
			bullet[temp[0]+3]=-4;
			bullet[temp[0]+4]=-4;
			bullet[temp[0]+5]=30;
		}
	}
	temp[0]=temp[0]+6;
	if(temp[0]<47) goto bulletcheck;
}
bulletstuff(void){
	temp[3]=0;
	redobullets:
	bulletdelay=bulletdelay-1;
	if(bulletdelay<0) bulletdelay=0;
	temp[0]=0;
	movingbullets:
	if(bullet[temp[0]]==1){
		if(temp[3]==1) Sprite8 (bullet[temp[0]+1],bullet[temp[0]+2],2,bulletsprite,LCD_MEM,SPRT_OR);
		bullet[temp[0]+1]=bullet[temp[0]+1]+bullet[temp[0]+3]/2;
		bullet[temp[0]+2]=bullet[temp[0]+2]+bullet[temp[0]+4]/2;
		if(bullet[temp[0]+1]<0) bullet[temp[0]+1]=LCD_WIDTH;
		if(bullet[temp[0]+1]>LCD_WIDTH) bullet[temp[0]+1]=0;
		if(bullet[temp[0]+2]<0) bullet[temp[0]+2]=LCD_HEIGHT;
		if(bullet[temp[0]+2]>LCD_HEIGHT) bullet[temp[0]+2]=0;
		bullet[temp[0]+5]=bullet[temp[0]+5]-1;
		if(bullet[temp[0]+5]==0) bullet[temp[0]]=0;
	}
	temp[0]=temp[0]+6;
	if(temp[0]<47) goto movingbullets;
	detectcollisions();
	if(temp[3]==0){
		temp[3]=1;
		goto redobullets;
	}
}
createlevel(void){
	for(temp[0]=0;temp[0]<47;temp[0]=temp[0]+1) bullet[temp[0]]=0;
  ship[0]=(LCD_WIDTH/2)-8;  //ship x coordinate
  ship[1]=(LCD_HEIGHT/2)-4;  //ship y coordinate
  ship[2]=0;  //ship direction 0-7, starting at up, rotating clockwise
  ship[3]=0;  //ship x-speed
  ship[4]=0;  //ship y-speed
  ship[5]=50;  //shield left
  ship[7]=0;  //delay after hit by asteroid for next hit
  shieldstate=0;  //shield on/off	
	if(level==1){
		bigasteroid[0]=1;
		bigasteroid[1]=LCD_WIDTH/2+10;
		bigasteroid[2]=LCD_HEIGHT/2+10;
		bigasteroid[3]=random(5)-2;
		bigasteroid[4]=random(3);
	}
	if(level==2){
		bigasteroid[0]=1;
		bigasteroid[1]=LCD_WIDTH/2+10;
		bigasteroid[2]=LCD_HEIGHT/2+10;
		bigasteroid[3]=random(5)-2;
		bigasteroid[4]=random(3);
		bigasteroid[5]=1;
		bigasteroid[6]=LCD_WIDTH/2-30;
		bigasteroid[7]=LCD_HEIGHT/2-30;
		bigasteroid[8]=random(5)-2;
		bigasteroid[9]=random(3)-3;
	}
	if(level==3){
		bigasteroid[0]=1;
		bigasteroid[1]=LCD_WIDTH/2+10;
		bigasteroid[2]=LCD_HEIGHT/2+10;
		bigasteroid[3]=random(5)-2;
		bigasteroid[4]=random(3);
		bigasteroid[5]=1;
		bigasteroid[6]=LCD_WIDTH/2-30;
		bigasteroid[7]=LCD_HEIGHT/2-30;
		bigasteroid[8]=random(5)-2;
		bigasteroid[9]=random(3)-3;
		bigasteroid[10]=1;
		bigasteroid[11]=LCD_WIDTH/2-30;
		bigasteroid[12]=LCD_HEIGHT/2+10;
		bigasteroid[13]=random(3)-3;
		bigasteroid[14]=random(5)-2;
	}
	if(level>3){
		bigasteroid[0]=1;
		bigasteroid[1]=LCD_WIDTH/2+10;
		bigasteroid[2]=LCD_HEIGHT/2+10;
		bigasteroid[3]=random(5)-2;
		bigasteroid[4]=random(3);
		bigasteroid[5]=1;
		bigasteroid[6]=LCD_WIDTH/2-30;
		bigasteroid[7]=LCD_HEIGHT/2-30;
		bigasteroid[8]=random(5)-2;
		bigasteroid[9]=random(3)-3;
		bigasteroid[10]=1;
		bigasteroid[11]=LCD_WIDTH/2-30;
		bigasteroid[12]=LCD_HEIGHT/2+10;
		bigasteroid[13]=random(3)-3;
		bigasteroid[14]=random(5)-2;
		bigasteroid[15]=1;
		bigasteroid[16]=LCD_WIDTH/2+10;
		bigasteroid[17]=LCD_HEIGHT/2-30;
		bigasteroid[18]=random(3);
		bigasteroid[19]=random(5)-2;
	}
}
drawasteroids(void){
	temp[0]=0;
	drawbigasteroidloop:
	if(bigasteroid[temp[0]]==1){
		Sprite16 (bigasteroid[temp[0]+1],bigasteroid[temp[0]+2],16,basteroid,LCD_MEM,SPRT_XOR);
	}
	temp[0]=temp[0]+5;
	if(temp[0]<20) goto drawbigasteroidloop;
	temp[0]=0;
	drawlittleasteroidloop:
	if(littleasteroid[temp[0]]==1){
		Sprite8 (littleasteroid[temp[0]+1],littleasteroid[temp[0]+2],8,lasteroid,LCD_MEM,SPRT_XOR);
	}
	temp[0]=temp[0]+5;
	if(temp[0]<80) goto drawlittleasteroidloop;
}
moveasteroids(){
	temp[0]=0;
	movebigasteroidsloop:
	if(bigasteroid[temp[0]]==1){
		bigasteroid[temp[0]+1]=bigasteroid[temp[0]+1]+bigasteroid[temp[0]+3];
		bigasteroid[temp[0]+2]=bigasteroid[temp[0]+2]+bigasteroid[temp[0]+4];
		if(bigasteroid[temp[0]+1]<0) bigasteroid[temp[0]+1]=LCD_WIDTH-15;
		if(bigasteroid[temp[0]+1]>LCD_WIDTH-15) bigasteroid[temp[0]+1]=0;
		if(bigasteroid[temp[0]+2]<0) bigasteroid[temp[0]+2]=LCD_HEIGHT-15;
		if(bigasteroid[temp[0]+2]>LCD_HEIGHT-15) bigasteroid[temp[0]+2]=0;
	}
	temp[0]=temp[0]+5;
	if(temp[0]<20) goto movebigasteroidsloop;
	temp[0]=0;
	movelittleasteroidsloop:
	if(littleasteroid[temp[0]]==1){
		littleasteroid[temp[0]+1]=littleasteroid[temp[0]+1]+littleasteroid[temp[0]+3];
		littleasteroid[temp[0]+2]=littleasteroid[temp[0]+2]+littleasteroid[temp[0]+4];
		if(littleasteroid[temp[0]+1]<0) littleasteroid[temp[0]+1]=LCD_WIDTH-7;
		if(littleasteroid[temp[0]+1]>LCD_WIDTH-7) littleasteroid[temp[0]+1]=0;
		if(littleasteroid[temp[0]+2]<0) littleasteroid[temp[0]+2]=LCD_HEIGHT-7;
		if(littleasteroid[temp[0]+2]>LCD_HEIGHT-7) littleasteroid[temp[0]+2]=0;
	}
	temp[0]=temp[0]+5;
	if(temp[0]<80) goto movelittleasteroidsloop;
}
	clearvariables(void){
	for(temp[0]=0;temp[0]<9;temp[0]=temp[0]+1) ship[temp[0]]=0;
	for(temp[0]=0;temp[0]<47;temp[0]=temp[0]+1) bullet[temp[0]]=0;
	for(temp[0]=0;temp[0]<19;temp[0]=temp[0]+1) bigasteroid[temp[0]]=0;
	for(temp[0]=0;temp[0]<79;temp[0]=temp[0]+1) littleasteroid[temp[0]]=0;
	littleasteroid[0]=0;
}
detectcollisions(void){
	temp[0]=0;
	temp[1]=0;
	dctop:
	if(bigasteroid[temp[1]]==1&&bullet[temp[0]]==1&&bullet[temp[0]+1]>=bigasteroid[temp[1]+1]&&bullet[temp[0]+1]<=bigasteroid[temp[1]+1]+16&&bullet[temp[0]+2]>=bigasteroid[temp[1]+2]&&bullet[temp[0]+2]<=bigasteroid[temp[1]+2]+16){
		bigasteroid[temp[1]]=0;
		bullet[temp[0]]=0;
		temp[2]=0;
		foundbreak=0;
		score=score+10;
		breakuploop:
		if(littleasteroid[temp[2]]==0&&foundbreak==0){
			foundbreak=1;
			littleasteroid[temp[2]]=1;
			littleasteroid[temp[2]+1]=bigasteroid[temp[1]+1]-1;
			littleasteroid[temp[2]+2]=bigasteroid[temp[1]+2]-1;
			littleasteroid[temp[2]+3]=random(5)-2;
			littleasteroid[temp[2]+4]=random(5)-2;
			littleasteroid[temp[2]+5]=1;
			littleasteroid[temp[2]+6]=bigasteroid[temp[1]+1]+1;
			littleasteroid[temp[2]+7]=bigasteroid[temp[1]+2]-1;
			littleasteroid[temp[2]+8]=random(5)-2;
			littleasteroid[temp[2]+9]=random(5)-2;
			littleasteroid[temp[2]+10]=1;
			littleasteroid[temp[2]+11]=bigasteroid[temp[1]+1]-1;
			littleasteroid[temp[2]+12]=bigasteroid[temp[1]+2]+1;
			littleasteroid[temp[2]+13]=random(5)-2;
			littleasteroid[temp[2]+14]=random(5)-2;
			littleasteroid[temp[2]+15]=1;
			littleasteroid[temp[2]+16]=bigasteroid[temp[1]+1]+1;
			littleasteroid[temp[2]+17]=bigasteroid[temp[1]+2]+1;
			littleasteroid[temp[2]+18]=random(5)-2;
			littleasteroid[temp[2]+19]=random(5)-2;
		}
		temp[2]=temp[2]+20;
		if(temp[2]<80) goto breakuploop;
	}
	temp[0]=temp[0]+6;
	if(temp[0]<47) goto dctop;
	temp[0]=0;
	temp[1]=temp[1]+5;
	if(temp[1]<20) goto dctop;
	temp[0]=0;
	temp[1]=0;
	dctop2:
	if(littleasteroid[temp[1]]==1&&bullet[temp[0]]==1&&bullet[temp[0]+1]>=littleasteroid[temp[1]+1]&&bullet[temp[0]+1]<=littleasteroid[temp[1]+1]+8&&bullet[temp[0]+2]>=littleasteroid[temp[1]+2]&&bullet[temp[0]+2]<=littleasteroid[temp[1]+2]+8){
		littleasteroid[temp[1]]=0;
		bullet[temp[0]]=0;
		score=score+15;
	}
	temp[0]=temp[0]+6;
	if(temp[0]<47) goto dctop2;
	temp[0]=0;
	temp[1]=temp[1]+5;
	if(temp[1]<80) goto dctop2;
	temp[0]=0;
	dctop3:
	if(bigasteroid[temp[0]]==1&&abs((ship[0]+5)-(bigasteroid[temp[0]+1]+8))<=13&&abs((ship[1]+4)-(bigasteroid[temp[0]+2]+8))<=12&&ship[7]==0){
		if(shieldstate==0) ship[6]=ship[6]-1;
		if(ship[3]!=0||ship[4]!=0) ship[3]=-ship[3]*4;
		if(ship[3]!=0||ship[4]!=0) ship[4]=-ship[4]*4;
		if(ship[3]==0&&ship[4]==0){
			ship[3]=bigasteroid[temp[0]+3]*4;
			ship[4]=bigasteroid[temp[0]+4]*4;
		}
		if(ship[3]<0) ship[3]=-4;
		if(ship[4]<0) ship[4]=-4;
		if(ship[3]>0) ship[3]=4;
		if(ship[4]>0) ship[4]=4;
		ship[7]=4;
	}
	temp[0]=temp[0]+5;
	if(temp[0]<20) goto dctop3;
	temp[0]=0;
	dctop4:
	if(littleasteroid[temp[0]]==1&&abs((ship[0]+5)-(littleasteroid[temp[0]+1]+4))<=9&&abs((ship[1]+4)-(littleasteroid[temp[0]+2]+4))<=8&&ship[7]==0){
		if(shieldstate==0) ship[6]=ship[6]-1;
		if(ship[3]!=0||ship[4]!=0) ship[3]=-ship[3]*4;
		if(ship[3]!=0||ship[4]!=0) ship[4]=-ship[4]*4;
		if(ship[3]==0&&ship[4]==0){
			ship[3]=littleasteroid[temp[0]+3]*4;
			ship[4]=littleasteroid[temp[0]+4]*4;
		}
		if(ship[3]<0) ship[3]=-4;
		if(ship[4]<0) ship[4]=-4;
		if(ship[3]>0) ship[3]=4;
		if(ship[4]>0) ship[4]=4;
		ship[7]=4;
	}
	temp[0]=temp[0]+5;
	if(temp[0]<80) goto dctop4;
}
shieldstuff(void){
	if(shieldstate==1){
		Sprite16 (ship[0]-3,ship[1]-4,16,shieldsprite,LCD_MEM,SPRT_XOR);
	}
}
drawstatusbars(void){
	DrawLine(LCD_WIDTH-1,LCD_HEIGHT,LCD_WIDTH-1,(LCD_HEIGHT-(LCD_HEIGHT/50)*ship[5]),A_NORMAL);
	DrawLine(1,LCD_HEIGHT,1,(LCD_HEIGHT-(LCD_HEIGHT/10)*ship[6]),A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr(LCD_WIDTH/2-27,LCD_HEIGHT-6,"Score:",A_NORMAL);
	sprintf(buffer,"%d",score);
	DrawStr(LCD_WIDTH/2-4,LCD_HEIGHT-6,buffer,A_NORMAL);	
  OSSetSR (0x0700);
}
checkmisc(void){
	temp[1]=0;
	for(temp[0]=0;temp[0]<80;temp[0]=temp[0]+5) temp[1]=temp[1]+littleasteroid[temp[0]];
	if(temp[1]==0&&bigasteroid[0]==0&&bigasteroid[5]==0&&bigasteroid[10]==0&&bigasteroid[15]==0){
		level=level+1;
		createlevel();
	}
	if(ship[6]==0){
		clrscr();
		FontSetSys(F_6x8);
		DrawStr(LCD_WIDTH/2-30,LCD_HEIGHT/2-10,"Game Over",A_NORMAL);
		DrawStr(LCD_WIDTH/2-20,LCD_HEIGHT/2,"Score:",A_NORMAL);
		sprintf(buffer,"%d",score);
		DrawStr(LCD_WIDTH/2+22,LCD_HEIGHT/2,buffer,A_NORMAL);
		DrawStr(LCD_WIDTH/2-50,LCD_HEIGHT/2+10,"High Score:",A_NORMAL);	
		sprintf(buffer,"%d",highscore);
		DrawStr(LCD_WIDTH/2+22,LCD_HEIGHT/2+10,buffer,A_NORMAL);
		if(score>highscore){
			highscore=score;
			DrawStr(LCD_WIDTH/2-50,LCD_HEIGHT/2+20,"New High Score!",A_NORMAL);
		}
		do{
		} while(ngetchx()!=13);
		exit(0);
	}
}
